function gm_prefs(){
  this.prefBranch = null;
  
  // pref values
  this.PREF_STATUSBAR_ENABLED     = "gm-notifier.sidebar.enabled"; // oops, sidebar?
  this.PREF_UPDATE_INTERVAL       = "gm-notifier.update.interval";
  this.PREF_LOAD_LOCATION         = "gm-notifier.loadgm.location";
  this.PREF_LOAD_RESET_COUNTER    = "gm-notifier.loadgm.reset_counter";
  this.PREF_AUTOLOGIN_ENABLED     = "gm-notifier.autologin.enabled";
  this.PREF_NOTIFICATIONS_ENABLED = "gm-notifier.ui.notification.enabled";
  this.PREF_SOUNDNOTIFICATIONS_ENABLED = "gm-notifier.ui.soundnotification.enabled";
  this.PREF_SOUNDNOTIFICATIONS_URI = "gm-notifier.ui.soundnotification.uri";
  this.PREF_DEFAULT_USER          = "gm-notifier.users.default";
  this.PREF_REMEMBER_PASSWORD     = "gm-notifier.users.remember-password";
  this.PREF_IS_LOGGED_IN          = "gm-notifier.loggedin";
}

gm_prefs.prototype.getPrefBranch = function(){
  if (!this.prefBranch){ 
    this.prefBranch = Components.classes['@mozilla.org/preferences-service;1'].getService();
    this.prefBranch = this.prefBranch.QueryInterface(Components.interfaces.nsIPrefBranch);
  }
  
  return this.prefBranch;
}

gm_prefs.prototype.setBoolPref = function(aName, aValue){
  this.getPrefBranch().setBoolPref(aName, aValue);
}


gm_prefs.prototype.getBoolPref = function(aName){
  var rv = null;

  try{
    rv = this.getPrefBranch().getBoolPref(aName);
  } catch (e){
  
  }
  
  return rv;
}

gm_prefs.prototype.setIntPref = function(aName, aValue){
  this.getPrefBranch().setIntPref(aName, aValue);
}


gm_prefs.prototype.getIntPref = function(aName){
  var rv = null;

  try{
    rv = this.getPrefBranch().getIntPref(aName);
  } catch (e){
  
  }
  
  return rv;
}

gm_prefs.prototype.setCharPref = function(aName, aValue){
  this.getPrefBranch().setCharPref(aName, aValue);
}

gm_prefs.prototype.getCharPref = function(aName){
  var rv = null;

  try{
    rv = this.getPrefBranch().getCharPref(aName);
  } catch (e){
  
  }
  
  return rv;
}

gm_prefs.prototype.addObserver = function(aDomain, aFunction){
  var myPrefs = this.getPrefBranch();
  var prefBranchInternal = myPrefs.QueryInterface(Components.interfaces.nsIPrefBranchInternal);
                                                                                             
  if (prefBranchInternal)
    prefBranchInternal.addObserver(aDomain, aFunction, false);
}

gm_prefs.prototype.removeObserver = function(aDomain, aFunction){
  var myPrefs = this.getPrefBranch();
  var prefBranchInternal = myPrefs.QueryInterface(Components.interfaces.nsIPrefBranchInternal);
                                                                                             
  if (prefBranchInternal)
    prefBranchInternal.removeObserver(aDomain, aFunction);
}